version: '3.9'

x-project-defaults: &project_defaults
  networks:
    - project
  restart: always
  env_file:
    ./.env
  logging:
    options:
      max-size: "1m"
      max-file: "1"
    driver: json-file

x-minio-defaults: &minio_defaults
  <<: *project_defaults
  image: minio/minio
  command: server http://minio{1...4}/data{1...2}
  expose:
    - "9000"
  healthcheck:
    test: ["CMD", "curl", "-f", "http://localhost:9000/minio/health/live"]
    interval: 30s
    timeout: 20s
    retries: 3


services:
  traefik:
    <<: *project_defaults
    image: ${TRAEFIK_IMAGE:-traefik:v2.6}
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
    healthcheck:
      test: ["CMD", "traefik", "healthcheck", "--ping"]
      interval: 10s
      timeout: 5s
      retries: 3
      start_period: 5s
    ports:
      - 80:80
      - 8080:8080
    command:
      - --api.insecure=true
      - --providers.docker=true
      - --providers.docker.exposedbydefault=false
      - --entrypoints.web.address=:80
      - --ping

  sidekick:
    <<: *project_defaults
    image: minio/sidekick
    command: --debug --health-path=/minio/health/ready --address :8000 http://minio{1...4}:9000
    labels:
      - traefik.enable=true
      - traefik.http.routers.sidekick.rule=Host(`${MINIO_DOMAIN}`)
      - traefik.http.routers.sidekick.entrypoints=web

  console:
    <<: *project_defaults
    image: minio/console
    command: server
    environment:
      - "CONSOLE_PBKDF_PASSPHRASE=demoapp"
      - "CONSOLE_PBKDF_SALT=demoapp"
      - "CONSOLE_MINIO_SERVER=http://sidekick:8000"
    labels:
      - traefik.enable=true
      - traefik.http.routers.console.rule=Host(`${MINIO_CONSOLE_DOMAIN}`)
      - traefik.http.routers.console.entrypoints=web

  minio1:
    <<: *minio_defaults
    hostname: minio1
    volumes:
      - data1-1:/data1
      - data1-2:/data2
    
  minio2:
    <<: *minio_defaults
    hostname: minio2
    volumes:
      - data2-1:/data1
      - data2-2:/data2

  minio3:
    <<: *minio_defaults
    hostname: minio3
    volumes:
      - data3-1:/data1
      - data3-2:/data2

  minio4:
    <<: *minio_defaults
    hostname: minio4
    volumes:
      - data4-1:/data1
      - data4-2:/data2


volumes:
  data1-1:
  data1-2:
  data2-1:
  data2-2:
  data3-1:
  data3-2:
  data4-1:
  data4-2:

networks:
  project:
    name: ${PROJECT_NAME}
